;
; ணࠬ "MakeInc".  1.1
;
; ⨫  ᮧ 砥 䠩  ᥬ, ᮤঠ饣 
;    䠩
;
; ⠪  ப :
;   makeinc[.com] <筨> <१>
;
; ⥬ ॡ :
;    PC/AT  ᮢ⨬
;    80386+
;    MS-DOS 3.0+
;
;  ᮧ : 08.07.2001
;  ᫥ 䨪樨 : 08.07.2001
;
; Copyright (c) 2001 ᨫ쭨 
;

TITLE Utility "MakeInc"

BYTES_PER_BLOCK	equ 8		; 쪮   室 䠩 室 
				;  ப १饣

code	segment public byte 'code'
	assume	cs:code, ds:code, ss:code
	org	100h
	.386

start:	jmp	end_copyright

	db	13, 10, 13, 10
	db	"------------------------------------", 13, 10
	db	'   Program "MakeInc". Version 1.1   ', 13, 10
	db	"   Copyright (c) Krasilnikov Ivan   ", 13, 10
	db	"             July, 2001             ", 13, 10
	db	"------------------------------------", 13, 10
	db	13, 10

end_copyright:

	lea	si, szTitleMessage
	call	WriteString

	call	ParseCommandLine
	jc	out_help

	call	OpenFiles
	call	WriteTitle
decoding_cycle:
	call	ReadBlock
	call	DecodeBlock
	call	WriteBlock
	cmp	eof_flag, 0
	je	decoding_cycle
	call	CloseFiles

	lea	si, szCompleted
	call	WriteString

	mov	al, 0
_exit:	mov	ah, 4Ch
	int	21h

out_help:
	lea	si, szHelpMessage
	call	WriteString
	mov	al, 1
	jmp	_exit

write_error:
	lea	si, szWriteError
	call	WriteString
	lea	si, dest_file
	call	WriteString
	lea	si, szWriteError2
	call	WriteString
	call	CloseFiles
	mov	al, 2
	jmp	_exit

read_error:
	lea	si, szReadError
	call	WriteString
	lea	si, source_file
	call	WriteString
	lea	si, szReadError2
	call	WriteString
	call	CloseFiles
	mov	al, 3
	jmp	_exit

;
; ணࠬ 祭 ࠬ஢   ப. ⠪
; ਭ  ப :
;
;   < 䠩 筨> < 䠩 祭>
;
; ᫨ ࠬ஢ 筮, ࠢ 頥  ⠭ 䫠
; ७ (CF)
;
ParseCommandLine	proc	near

	mov	al, byte ptr cs:[80h]
	cmp	al, 3
	jb	not_enough_params
	add	al, 81h
	movzx	si, al
	mov	byte ptr ds:[si], 0

	lea	si, ds:[81h]
	lea	di, source_file

skip_spaces:
	lodsb
	call	isspace
	jc	skip_spaces
	dec	si

next_src_chr:
	lodsb
	or	al, al
	jz	not_enough_params
	call	isspace
	jc	end_src_name
	stosb
	jmp	next_src_chr

end_src_name:
	mov	al, 0
	stosb

skip_spaces2:
	lodsb
	or	al, al
	jz	not_enough_params
	call	isspace
	jc	skip_spaces2
	dec	si

	lea	di, dest_file
next_dest_chr:
	lodsb
	or	al, al
	jz	end_dest_name
	call	isspace
	jc	end_dest_name
	stosb
	jmp	next_dest_chr

end_dest_name:
	mov	al, 0
	stosb

	clc
	ret

not_enough_params:
	stc
	ret

;
; 㭪 : isspace
;
; 祭 : ஢ઠ ᨬ  ਭ  ᨬ-ࠧ⥫
; ࠬ஢ (஡, ⠡, ॢ ⪨,  ப)
; 
;  室 : al
;
;  室 :
;   CF=0, ᨬ   ࠧ⥫
;   CF=1, ᨬ  ࠧ⥫
;
isspace	proc	near

	cmp	al, 20h
	je	result_true
	cmp	al, 9
	je	result_true
	cmp	al, 13
	je	result_true
	cmp	al, 10
	je	result_true
	clc
	ret

result_true:
	stc
	ret

isspace	endp

ParseCommandLine	endp

;
; ணࠬ   䠩 筨  祭  ⥭  
; ᮮ⢥⢥
;
OpenFiles	proc	near

	mov	ah, 3Dh			; open file
	mov	al, 00100000b		; read/deny write
	lea	dx, source_file
	int	21h
	jc	open_src_error
	mov	source_handle, ax

	mov	ah, 3Ch			; create/overwrite file
	mov	cx, 32			; attr=archive
	lea	dx, dest_file
	int	21h
	jc	open_dst_error
	mov	dest_handle, ax

	ret

open_src_error:
	lea	di, source_file
	jmp	out_open_err_msg
open_dst_error:
	mov	ah, 3Eh			; close file
	mov	bx, source_handle
	int	21h
	lea	di, dest_file
out_open_err_msg:
	lea	si, szOpenError
	call	WriteString
	mov	si, di
	call	WriteString
	lea	si, szOpenError2
	call	WriteString
	mov	al, 2
	jmp	_exit

OpenFiles	endp

;
; ணࠬ   ᯮ㥬 䠩
;
CloseFiles	proc	near

	mov	ah, 3Eh
	mov	bx, source_handle
	int	21h

	mov	ah, 3Eh
	mov	bx, dest_handle
	int	21h

	ret

CloseFiles	endp

;
; ணࠬ   쭮 ப  䠩 祭
;
WriteTitle	proc	near

	lea	si, szFileTitle
	call	strlen
	mov	ah, 40h
	mov	bx, dest_handle
	mov	dx, si
	int	21h
	jc	write_error

	lea	si, source_file
	call	strlen
	mov	ah, 40h
	mov	dx, si
	int	21h
	jc	write_error

	lea	si, szFileTitle2
	call	strlen
	mov	ah, 40h
	mov	dx, si
	int	21h
	jc	write_error

	mov	ah, 2Ah
	int	21h
	mov	al, dl			; ᫮
	aam
	add	ax, 3030h
	mov	time_stamp[0], ah
	mov	time_stamp[1], al
	mov	al, dh			; 
	aam
	add	ax, 3030h
	mov	time_stamp[3], ah
	mov	time_stamp[4], al
	mov	ax, cx			; 
	mov	bl, 100
	div	bl
	push	ax
	aam
	add	ax, 3030h
	mov	time_stamp[6], ah
	mov	time_stamp[7], al
	pop	ax
	mov	al, ah
	aam
	add	ax, 3030h
	mov	time_stamp[8], ah
	mov	time_stamp[9], al

	mov	ah, 2Ch
	int	21h
	mov	al, ch			; 
	aam
	add	ax, 3030h
	mov	time_stamp[11], ah
	mov	time_stamp[12], al
	mov	al, cl			; 
	aam
	add	ax, 3030h
	mov	time_stamp[14], ah
	mov	time_stamp[15], al
	mov	al, dh			; ᥪ㭤
	aam
	add	ax, 3030h
	mov	time_stamp[17], ah
	mov	time_stamp[18], al

	lea	si, time_stamp
	call	strlen
	mov	ah, 40h
	mov	bx, dest_handle
	mov	dx, si
	int	21h
	jc	write_error

	lea	si, szFileTitle3
	call	strlen
	mov	ah, 40h
	mov	dx, si
	int	21h
	jc	write_error

	ret

time_stamp	db "dd.mm.yyyy hh:mm:ss", 0

WriteTitle	endp

;
; ணࠬ ⥭ ।   䠩-筨
;
ReadBlock	proc	near

	mov	eof_flag, 0
	mov	ah, 3Fh
	mov	bx, source_handle
	mov	cx, BYTES_PER_BLOCK
	lea	dx, block_data
	int	21h
	jc	read_error
	mov	block_size, ax
	cmp	ax, BYTES_PER_BLOCK
	ja	read_error
	jnb	no_eof
	mov	eof_flag, 1
no_eof:	ret

ReadBlock	endp

;
; ணࠬ  ८ࠧ    ⥪饣  
;  ࠧ  ᥬ (१ ४⨢ db)
;
DecodeBlock	proc	near

	cmp	block_size, 0
	je	empty_block

	mov	dword ptr block_decode[0],  09626409h	; TAB, 'db', TAB
	mov	si, 0
	lea	di, block_decode[4]
decode_byte:
	cmp	si, 0
	je	skip_comma
	mov	al, ','
	stosb
	mov	al, 20h
	stosb
skip_comma:
	mov	al, '0'
	stosb
	mov	ah, block_data[si]
	mov	al, ah
	shr	al, 4
	lea	bx, hex_xlat
	xlat
	stosb
	mov	al, ah
	and	al, 0Fh
	xlat
	stosb
	mov	al, 'h'
	stosb
	inc	si
	cmp	si, block_size
	jb	decode_byte
	mov	al, 13
	stosb
	mov	al, 10
	stosb
	mov	al, 0
	stosb
	ret

empty_block:
	mov	block_decode[0], 0
	ret

hex_xlat	db "0123456789ABCDEF"

DecodeBlock	endp

;
; ணࠬ   ८ࠧ   १騩 䠩
;
WriteBlock	proc	near
	lea	si, block_decode
	call	strlen
	or	cx, cx
	jz	empty_block
	mov	ah, 40h
	mov	bx, dest_handle
	mov	dx, si
	int	21h
	jc	write_error
empty_block:
	ret
WriteBlock	endp

;
; 楤 : WriteString
;
; 祭 : 뢮  ன⢮ stdout ப, 稢饩 㫥 (ASCIIZ)
;
;  室 :
;   ds:si -  ப
;
;  室 : 祣
;
WriteString	proc	near
	push	ax
	push	si
	mov	ah, 02h
nxtchr:	mov	dl, ds:[si]
	or	dl, dl
	jz	endstr
	int	21h
	inc	si
	jmp	short nxtchr
endstr:	pop	si
	pop	ax
	ret
WriteString	endp

;
; 㭪 : strlen
;
; 祭 :    ப ASCIIZ
;
;  室 :
;   ds:si -  ப
;
;  室 :
;   cx -  ப   (     ப)
;
strlen	proc	near
	push	ax
	push	si
	xor	cx, cx
nxtchr:	lodsb
	or	al, al
	jz	endstr
	inc	cx
	jmp	nxtchr
endstr:	pop	si
	pop	ax
	ret
strlen	endp

;
;  ᮮ饭
;

szTitleMessage	db "ணࠬ MakeInc.  1.1", 13, 10
		db "Copyright (c) 2001 ᨫ쭨 ", 13, 10
		db 13, 10, 0

szHelpMessage	db "⠪  ப :", 13, 10
		db "  makeinc[.com] <筨> <१>", 13, 10
		db 13, 10
		db "<筨> -  䠩  室묨 묨", 13, 10
		db "<१> -  䠩,   㦭  ᥬ ࠧ ", 13, 10, 0

szCompleted	db " ࠧ  襭", 13, 10, 0

szOpenError	db '訡  ⪥  䠩 "', 0
szOpenError2	db '"', 13, 10, 0

szWriteError	db '訡  ⪥   䠩 "', 0
szWriteError2	db '"', 13, 10, 0

szReadError	db '訡  ⪥ ⥭  䠩 "', 0
szReadError2	db '"', 13, 10, 0

szFileTitle	db ";", 13, 10
		db ";  䠩  ᮧ ணࠬ MakeInc ᨨ 1.1", 13, 10
		db ';  ᮤন 䠩 "', 0
szFileTitle2	db '", ', 0
szFileTitle3	db 13, 10
		db "; (c) 2001 ᨫ쭨 ", 13, 10
		db ";", 13, 10, 13, 10, 0

;
;  樠஢ 
;

_bss		equ	$			;   :

source_file	equ byte ptr _bss		; 80
dest_file	equ byte ptr _bss+80		; 80

source_handle	equ word ptr _bss+160		; 2
dest_handle	equ word ptr _bss+162		; 2

eof_flag	equ byte ptr _bss+164		; 1
block_size	equ word ptr _bss+165		; 2
block_data	equ byte ptr _bss+167		; BYTES_PER_BLOCK
block_decode	equ byte ptr _bss+170+BYTES_PER_BLOCK
						; (10+6*BYTES_PER_BLOCK)

code	ends

	end	start
